var app = new Vue({
  el: '#app',
  data: {
    urlParams: {},
    series: {}
  },
  methods: {
    urlParse: function() {
      var match,
      pl     = /\+/g,  // Regex for replacing addition symbol with a space
      search = /([^&=]+)=?([^&]*)/g,
      decode = function (s) { return decodeURIComponent(s.replace(pl, " ")); },
      query  = window.location.search.substring(1);
      while (match = search.exec(query))
        this.urlParams[decode(match[1])] = decode(match[2]);
    },
    sendQuery: function(url, error, success) {
      var xmh = new XMLHttpRequest();
      var v;

      xmh.onreadystatechange = function() {
        v = xmh.responseText;
        if (xmh.readyState === 4 && xmh.status === 200) {
          var res;
          try  { 
            res = JSON.parse(v);
          } catch (err) {
            if (null !== error)
              error(err.name, err.message);
          }
          if (null !== success)
            success(res);
        } else if (xmh.readyState === 4) {
          if (null !== error)
            error(xmh.status, v);
        }
      };

      xmh.open('GET', url, true);
      xmh.send(null);
    },
    stdError: function(code, resp) {
      console.log('ERROR ' + code + ': ' + resp);
    },
    seriesSucces: function(resp) {
      this.series = resp;
      document.title = this.series.name +' | Bouquins';
    },
    loadSeries: function() {
      if (this.urlParams.id)
        this.sendQuery('cgi-bin/bouquins/series/' + this.urlParams.id, this.stdError, this.seriesSucces);
    }
  },
  created: function() {
    this.urlParse();
  },
  mounted: function() {
    this.loadSeries();
  }
})
